package exnihilocreatio.registries.manager;

import exnihilocreatio.ModBlocks;
import exnihilocreatio.ModFluids;
import exnihilocreatio.ModItems;
import exnihilocreatio.blocks.BlockSieve.MeshType;
import exnihilocreatio.items.EnumPebbleSubtype;
import exnihilocreatio.items.ItemPebble;
import exnihilocreatio.items.ItemResource;
import exnihilocreatio.items.ore.ItemOre;
import exnihilocreatio.items.seeds.ItemSeedBase;
import exnihilocreatio.registries.registries.*;
import exnihilocreatio.registries.types.Meltable;
import exnihilocreatio.texturing.Color;
import exnihilocreatio.util.BlockInfo;
import exnihilocreatio.util.ItemInfo;
import exnihilocreatio.util.Util;
import net.minecraft.block.Block;
import net.minecraft.block.BlockStone;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fml.common.Loader;
import net.minecraftforge.fml.common.registry.GameRegistry.ObjectHolder;
import net.minecraftforge.oredict.OreDictionary;

import javax.annotation.Nullable;

public class ExNihiloDefaultRecipes {

    @Nullable
    @ObjectHolder("appliedenergistics2:material")
    public static final Item AE_MATERIAL = null; //SkyStone dust == 45

    public static void registerDefaults() {
        ExNihiloRegistryManager.registerSieveDefaultRecipeHandler(new SieveDefaults());
        ExNihiloRegistryManager.registerHammerDefaultRecipeHandler(new HammerDefaults());
        ExNihiloRegistryManager.registerCompostDefaultRecipeHandler(new CompostDefaults());
        ExNihiloRegistryManager.registerCrookDefaultRecipeHandler(new CrookDefaults());
        ExNihiloRegistryManager.registerHeatDefaultRecipeHandler(new HeatDefaults());
        ExNihiloRegistryManager.registerOreDefaultRecipeHandler(new OreDefaults());
        ExNihiloRegistryManager.registerBarrelLiquidBlacklistDefaultHandler(new BarrelLiquidBlacklistDefaults());
        ExNihiloRegistryManager.registerFluidOnTopDefaultRecipeHandler(new FluidOnTopDefaults());
        ExNihiloRegistryManager.registerFluidTransformDefaultRecipeHandler(new FluidTransformDefaults());
        ExNihiloRegistryManager.registerFluidBlockDefaultRecipeHandler(new FluidBlockTransformDefaults());
        ExNihiloRegistryManager.registerCrucibleStoneDefaultRecipeHandler(new CrucibleStoneDefaults());
        ExNihiloRegistryManager.registerCrucibleWoodDefaultRecipeHandler(new CrucibleWoodDefaults());
    }

    private static class CompostDefaults implements ICompostDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(CompostRegistry registry) {
            IBlockState dirtState = Blocks.field_150346_d.func_176223_P();

            registry.register(Items.field_151078_bh, 0, 0.1f, dirtState, new Color("C45631"));

            registry.register(Blocks.field_150345_g, 0, 0.125f, dirtState, new Color("35A82A"));
            registry.register(Blocks.field_150345_g, 1, 0.125f, dirtState, new Color("2E8042"));
            registry.register(Blocks.field_150345_g, 2, 0.125f, dirtState, new Color("6CC449"));
            registry.register(Blocks.field_150345_g, 3, 0.125f, dirtState, new Color("22A116"));
            registry.register(Blocks.field_150345_g, 4, 0.125f, dirtState, new Color("B8C754"));
            registry.register(Blocks.field_150345_g, 5, 0.125f, dirtState, new Color("378030"));

            registry.register(Blocks.field_150362_t, 0, 0.125f, dirtState, new Color("35A82A"));
            registry.register(Blocks.field_150362_t, 1, 0.125f, dirtState, new Color("2E8042"));
            registry.register(Blocks.field_150362_t, 2, 0.125f, dirtState, new Color("6CC449"));
            registry.register(Blocks.field_150362_t, 3, 0.125f, dirtState, new Color("22A116"));
            registry.register(Blocks.field_150361_u, 0, 0.125f, dirtState, new Color("B8C754"));
            registry.register(Blocks.field_150361_u, 1, 0.125f, dirtState, new Color("378030"));

            registry.register(Items.field_151070_bp, 0, 0.08f, dirtState, new Color("963E44"));

            registry.register(Items.field_151015_O, 0, 0.08f, dirtState, new Color("E3E162"));
            registry.register(Items.field_151014_N, 0, 0.08f, dirtState, new Color("35A82A"));
            registry.register(Items.field_151025_P, 0, 0.16f, dirtState, new Color("D1AF60"));

            registry.register(Blocks.field_150327_N, 0, 0.10f, dirtState, new Color("FFF461"));
            registry.register(Blocks.field_150328_O, 0, 0.10f, dirtState, new Color("FF1212"));
            registry.register(Blocks.field_150328_O, 1, 0.10f, dirtState, new Color("33CFFF"));
            registry.register(Blocks.field_150328_O, 2, 0.10f, dirtState, new Color("F59DFA"));
            registry.register(Blocks.field_150328_O, 3, 0.10f, dirtState, new Color("E3E3E3"));
            registry.register(Blocks.field_150328_O, 4, 0.10f, dirtState, new Color("FF3D12"));
            registry.register(Blocks.field_150328_O, 5, 0.10f, dirtState, new Color("FF7E29"));
            registry.register(Blocks.field_150328_O, 6, 0.10f, dirtState, new Color("FFFFFF"));
            registry.register(Blocks.field_150328_O, 7, 0.10f, dirtState, new Color("F5C4FF"));
            registry.register(Blocks.field_150328_O, 8, 0.10f, dirtState, new Color("E9E9E9"));

            registry.register(Blocks.field_150398_cm, 0, 0.10f, dirtState, new Color("FFDD00"));
            registry.register(Blocks.field_150398_cm, 1, 0.10f, dirtState, new Color("FCC7F0"));
            registry.register(Blocks.field_150398_cm, 4, 0.10f, dirtState, new Color("FF1212"));
            registry.register(Blocks.field_150398_cm, 5, 0.10f, dirtState, new Color("F3D2FC"));

            registry.register(Blocks.field_150338_P, 0, 0.10f, dirtState, new Color("CFBFB6"));
            registry.register(Blocks.field_150337_Q, 0, 0.10f, dirtState, new Color("D6A8A5"));

            registry.register(Items.field_151158_bO, 0, 0.16f, dirtState, new Color("E39A6D"));

            registry.register(Items.field_151147_al, 0, 0.2f, dirtState, new Color("FFA091"));
            registry.register(Items.field_151157_am, 0, 0.2f, dirtState, new Color("FFFDBD"));

            registry.register(Items.field_151082_bd, 0, 0.2f, dirtState, new Color("FF4242"));
            registry.register(Items.field_151083_be, 0, 0.2f, dirtState, new Color("80543D"));

            registry.register(Items.field_151076_bf, 0, 0.2f, dirtState, new Color("FFE8E8"));
            registry.register(Items.field_151077_bg, 0, 0.2f, dirtState, new Color("FA955F"));

            registry.register(Items.field_151115_aP, 0, 0.15f, dirtState, new Color("6DCFB3"));
            registry.register(Items.field_179566_aV, 0, 0.15f, dirtState, new Color("D8EBE5"));

            registry.register(Items.field_151115_aP, 1, 0.15f, dirtState, new Color("FF2E4A"));
            registry.register(Items.field_179566_aV, 1, 0.15f, dirtState, new Color("E87A3F"));

            registry.register(Items.field_151115_aP, 2, 0.15f, dirtState, new Color("FF771C"));
            registry.register(Items.field_151115_aP, 3, 0.15f, dirtState, new Color("DBFAFF"));

            registry.register(ModItems.resources, ItemResource.getMetaFromName(ItemResource.SILKWORM), 0.04f, dirtState, new Color("ff9966"));
            registry.register(ModItems.cookedSilkworm, 0, 0.04f, dirtState, new Color("cc6600"));

            registry.register(Items.field_151034_e, 0, 0.10f, dirtState, new Color("FFF68F"));
            registry.register(Items.field_151127_ba, 0, 0.04f, dirtState, new Color("FF443B"));
            registry.register(Blocks.field_150440_ba, 0, 1.0f / 6, dirtState, new Color("FF443B"));
            registry.register(Blocks.field_150423_aK, 0, 1.0f / 6, dirtState, new Color("FFDB66"));
            registry.register(Blocks.field_150428_aP, 0, 1.0f / 6, dirtState, new Color("FFDB66"));

            registry.register(Blocks.field_150434_aF, 0, 0.10f, dirtState, new Color("DEFFB5"));

            registry.register(Items.field_151172_bF, 0, 0.08f, dirtState, new Color("FF9B0F"));
            registry.register(Items.field_151174_bG, 0, 0.08f, dirtState, new Color("FFF1B5"));
            registry.register(Items.field_151168_bH, 0, 0.08f, dirtState, new Color("FFF1B5"));
            registry.register(Items.field_151170_bI, 0, 0.08f, dirtState, new Color("E0FF8A"));

            registry.register(Blocks.field_150392_bi, 0, 0.10f, dirtState, new Color("269900"));
            registry.register(Blocks.field_150395_bd, 0, 0.10f, dirtState, new Color("23630E"));
            registry.register(Blocks.field_150329_H, 1, 0.08f, dirtState, new Color("23630E"));
            registry.register(Items.field_151110_aK, 0, 0.08f, dirtState, new Color("FFFA66"));
            registry.register(Items.field_151075_bm, 0, 0.10f, dirtState, new Color("FF2B52"));
            registry.register(Items.field_151120_aE, 0, 0.08f, dirtState, new Color("9BFF8A"));
            registry.register(Items.field_151007_F, 0, 0.04f, dirtState, Util.whiteColor);
        }
    }

    private static class CrookDefaults implements ICrookDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(CrookRegistry registry) {
            registry.register(new BlockInfo(Blocks.field_150362_t, -1), ItemResource.getResourceStack(ItemResource.SILKWORM), 0.1f, 0f);
            registry.register(new BlockInfo(Blocks.field_150361_u, -1), ItemResource.getResourceStack(ItemResource.SILKWORM), 0.1f, 0f);
        }
    }

    private static class SieveDefaults implements ISieveDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(SieveRegistry registry) {
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 1f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 1f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 0.5f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 0.5f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 0.1f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("stone"), 0.1f, MeshType.STRING.getID());

            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("granite"), 0.5f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("granite"), 0.1f, MeshType.STRING.getID());

            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("diorite"), 0.5f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("diorite"), 0.1f, MeshType.STRING.getID());

            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("andesite"), 0.5f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemPebble.getPebbleStack("andesite"), 0.1f, MeshType.STRING.getID());

            registry.register(Blocks.field_150346_d.func_176223_P(), new ItemInfo(Items.field_151014_N, 0), 0.7f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), new ItemInfo(Items.field_151081_bc, 0), 0.35f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), new ItemInfo(Items.field_151080_bb, 0), 0.35f, MeshType.STRING.getID());

            registry.register(Blocks.field_150354_m.func_176223_P(), new ItemInfo(Items.field_151100_aR, 3), 0.03f, MeshType.STRING.getID());
            registry.register(Blocks.field_150354_m.func_176223_P(), new ItemInfo(Items.field_179562_cC, 0), 0.02f, MeshType.DIAMOND.getID());

            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151145_ak, 0), 0.25f, MeshType.FLINT.getID());
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151044_h, 0), 0.125f, MeshType.FLINT.getID());
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151100_aR, 4), 0.05f, MeshType.FLINT.getID());

            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151045_i, 0), 0.008f, MeshType.IRON.getID());
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151166_bC, 0), 0.008f, MeshType.IRON.getID());

            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151045_i, 0), 0.016f, MeshType.DIAMOND.getID());
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemInfo(Items.field_151166_bC, 0), 0.016f, MeshType.DIAMOND.getID());

            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151128_bU, 0), 1f, MeshType.FLINT.getID());
            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151128_bU, 0), 0.33f, MeshType.FLINT.getID());

            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151075_bm, 0), 0.1f, MeshType.STRING.getID());

            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151073_bk, 0), 0.02f, MeshType.DIAMOND.getID());
            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151128_bU, 0), 1f, MeshType.DIAMOND.getID());
            registry.register(Blocks.field_150425_aM.func_176223_P(), new ItemInfo(Items.field_151128_bU, 0), 0.8f, MeshType.DIAMOND.getID());

            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151100_aR, 15), 0.2f, MeshType.STRING.getID());
            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151016_H, 0), 0.07f, MeshType.STRING.getID());

            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151137_ax, 0), 0.125f, MeshType.IRON.getID());
            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151137_ax, 0), 0.25f, MeshType.DIAMOND.getID());

            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151114_aO, 0), 0.0625f, MeshType.IRON.getID());
            registry.register(ModBlocks.dust.func_176223_P(), new ItemInfo(Items.field_151065_br, 0), 0.05f, MeshType.IRON.getID());

            if (Loader.isModLoaded("tconstruct")) {
                Item.func_111206_d("");
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemInfo(Items.field_151065_br, 0), 0.05f, MeshType.IRON.getID());
            }

            // Custom Ores for other mods
            OreRegistry oreRegistry = ExNihiloRegistryManager.ORE_REGISTRY;

            // Gold from nether rack
            ItemOre gold = oreRegistry.getOreItem("gold");
            if (gold != null) {
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(gold, 1, 0), 0.25f, MeshType.FLINT.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(gold, 1, 0), 0.25f, MeshType.IRON.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(gold, 1, 0), 0.4f, MeshType.DIAMOND.getID());
            }

            // TCon support
            ItemOre ardite = oreRegistry.getOreItem("ardite");
            if (ardite != null) {
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(ardite, 1, 0), 0.1f, MeshType.FLINT.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(ardite, 1, 0), 0.2f, MeshType.IRON.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(ardite, 1, 0), 0.3f, MeshType.DIAMOND.getID());
            }

            ItemOre cobalt = oreRegistry.getOreItem("cobalt");
            if (cobalt != null) {
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(cobalt, 1, 0), 0.1f, MeshType.FLINT.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(cobalt, 1, 0), 0.2f, MeshType.IRON.getID());
                registry.register(ModBlocks.netherrackCrushed.func_176223_P(), new ItemStack(cobalt, 1, 0), 0.3f, MeshType.DIAMOND.getID());
            }

            // All default Ores
            for (ItemOre ore : oreRegistry.getItemOreRegistry()) {
                if (ore == ardite || ore == cobalt) continue;

                registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(ore, 1, 0), 0.2f, MeshType.FLINT.getID());
                registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(ore, 1, 0), 0.2f, MeshType.IRON.getID());
                registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(ore, 1, 0), 0.1f, MeshType.DIAMOND.getID());
            }

            // Seeds
            for (ItemSeedBase seed : ModItems.itemSeeds) {
                registry.register(Blocks.field_150346_d.func_176223_P(), new ItemStack(seed), 0.05f, MeshType.STRING.getID());
            }

            registry.register(Blocks.field_150346_d.func_176223_P(), ItemResource.getResourceStack(ItemResource.ANCIENT_SPORES), 0.05f, MeshType.STRING.getID());
            registry.register(Blocks.field_150346_d.func_176223_P(), ItemResource.getResourceStack(ItemResource.GRASS_SEEDS), 0.05f, MeshType.STRING.getID());

            // SkyStone dust
            //noinspection ConstantConditions
            if (AE_MATERIAL != null) {
                registry.register(ModBlocks.dust.func_176223_P(), new ItemStack(AE_MATERIAL, 1, 45), 0.1f, MeshType.FLINT.getID());
                registry.register(ModBlocks.dust.func_176223_P(), new ItemStack(AE_MATERIAL, 1, 45), 0.2f, MeshType.IRON.getID());
                registry.register(ModBlocks.dust.func_176223_P(), new ItemStack(AE_MATERIAL, 1, 45), 0.3f, MeshType.DIAMOND.getID());
            }

        }
    }

    private static class HammerDefaults implements IHammerDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(HammerRegistry registry) {
            registry.register(Blocks.field_150347_e.func_176223_P(), new ItemStack(Blocks.field_150351_n, 1), 0, 1.0F, 0.0F);
            registry.register(Blocks.field_150351_n.func_176223_P(), new ItemStack(Blocks.field_150354_m, 1), 0, 1.0F, 0.0F);
            registry.register(Blocks.field_150354_m.func_176223_P(), new ItemStack(ModBlocks.dust, 1), 0, 1.0F, 0.0F);
            registry.register(Blocks.field_150424_aL.func_176223_P(), new ItemStack(ModBlocks.netherrackCrushed, 1), 0, 1.0F, 0.0F);
            registry.register(Blocks.field_150377_bs.func_176223_P(), new ItemStack(ModBlocks.endstoneCrushed, 1), 0, 1.0F, 0.0F);

            // Hammering stone into pebbles (no idea why anyone should do that, but hey :P)
            registry.register(Blocks.field_150348_b.func_176223_P().func_177226_a(BlockStone.field_176247_a, BlockStone.EnumType.STONE), new ItemStack(ModItems.pebbles, 1, EnumPebbleSubtype.STONE.getMeta()), 1, 3F, 1.25F);
            registry.register(Blocks.field_150348_b.func_176223_P().func_177226_a(BlockStone.field_176247_a, BlockStone.EnumType.ANDESITE), new ItemStack(ModItems.pebbles, 1, EnumPebbleSubtype.ANDESITE.getMeta()), 1, 3F, 1.25F);
            registry.register(Blocks.field_150348_b.func_176223_P().func_177226_a(BlockStone.field_176247_a, BlockStone.EnumType.GRANITE), new ItemStack(ModItems.pebbles, 1, EnumPebbleSubtype.GRANITE.getMeta()), 1, 3F, 1.25F);
            registry.register(Blocks.field_150348_b.func_176223_P().func_177226_a(BlockStone.field_176247_a, BlockStone.EnumType.DIORITE), new ItemStack(ModItems.pebbles, 1, EnumPebbleSubtype.DIORITE.getMeta()), 1, 3F, 1.25F);
        }
    }

    private static class HeatDefaults implements IHeatDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(HeatRegistry registry) {
            // Vanilla fluids are weird, the "flowing" variant is simply a temporary state of checking if it can flow.
            // So, once the lava has spread out all the way, it will all actually be "still" lava.
            // Thanks Mojang <3
            registry.register(new BlockInfo(Blocks.field_150356_k, -1), 3);
            registry.register(new BlockInfo(Blocks.field_150353_l, -1), 3);
            registry.register(new BlockInfo(Blocks.field_150480_ab, -1), 4);
            registry.register(new BlockInfo(Blocks.field_150478_aa, -1), 1);
        }
    }

    private static class BarrelLiquidBlacklistDefaults implements IBarrelLiquidBlacklistDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(BarrelLiquidBlacklistRegistry registry) {
            registry.register(ModBlocks.barrelWood.getTier(), "lava");
            registry.register(ModBlocks.barrelWood.getTier(), "fire_water");
            registry.register(ModBlocks.barrelWood.getTier(), "rocket_fuel");

        }
    }

    private static class FluidOnTopDefaults implements IFluidOnTopDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(FluidOnTopRegistry registry) {
            registry.register(FluidRegistry.LAVA, FluidRegistry.WATER, new ItemInfo(Blocks.field_150343_Z.func_176223_P()));
            registry.register(FluidRegistry.WATER, FluidRegistry.LAVA, new ItemInfo(Blocks.field_150347_e.func_176223_P()));
        }
    }

    private static class OreDefaults implements IOreDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(OreRegistry registry) {
            registry.register("gold", new Color("FFFF00"), new ItemInfo(Items.field_151043_k, 0));
            registry.register("iron", new Color("BF8040"), new ItemInfo(Items.field_151042_j, 0));

            //TODO: Better way, will most likely never grab as it is just called before many mods init their oredict
            if (OreDictionary.getOres("oreCopper").size() > 0) {
                registry.register("copper", new Color("FF9933"), null);
            }

            if (OreDictionary.getOres("oreTin").size() > 0) {
                registry.register("tin", new Color("E6FFF2"), null);
            }

            if (OreDictionary.getOres("oreAluminium").size() > 0 || OreDictionary.getOres("oreAluminum").size() > 0) {
                registry.register("aluminium", new Color("BFBFBF"), null);
            }

            if (OreDictionary.getOres("oreLead").size() > 0) {
                registry.register("lead", new Color("330066"), null);
            }

            if (OreDictionary.getOres("oreSilver").size() > 0) {
                registry.register("silver", new Color("F2F2F2"), null);
            }

            if (OreDictionary.getOres("oreNickel").size() > 0) {
                registry.register("nickel", new Color("FFFFCC"), null);
            }

            Item tconstructIngots = Item.func_111206_d("tconstruct:ingots");

            if (tconstructIngots != null) {
                registry.register("ardite", new Color("FF751A"), new ItemInfo(tconstructIngots, 1));
                registry.register("cobalt", new Color("3333FF"), new ItemInfo(tconstructIngots, 0));
            }
        }
    }

    private static class FluidTransformDefaults implements IFluidTransformDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(FluidTransformRegistry registry) {
            registry.register("water", "witchwater", 12000, new BlockInfo[]{new BlockInfo(Blocks.field_150391_bh.func_176223_P())}, new BlockInfo[]{new BlockInfo(Blocks.field_150338_P.func_176223_P()), new BlockInfo(Blocks.field_150337_Q.func_176223_P())});
        }
    }

    private static class FluidBlockTransformDefaults implements IFluidBlockDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(FluidBlockTransformerRegistry registry) {
            registry.register(FluidRegistry.WATER, new ItemInfo(new ItemStack(ModBlocks.dust)), new ItemInfo(new ItemStack(Blocks.field_150435_aG)));
            registry.register(FluidRegistry.LAVA, new ItemInfo(new ItemStack(Items.field_151137_ax)), new ItemInfo(new ItemStack(Blocks.field_150424_aL)));
            registry.register(FluidRegistry.LAVA, new ItemInfo(new ItemStack(Items.field_151114_aO)), new ItemInfo(new ItemStack(Blocks.field_150377_bs)));
            registry.register(ModFluids.fluidWitchwater, new ItemInfo(new ItemStack(Blocks.field_150354_m)), new ItemInfo(new ItemStack(Blocks.field_150425_aM)));

            if (Loader.isModLoaded("appliedenergistics2")){
                Block skystoneBlock = Block.func_149684_b("appliedenergistics2:sky_stone_block");
                //noinspection ConstantConditions
                if (skystoneBlock != null && AE_MATERIAL != null){
                    registry.register(FluidRegistry.LAVA, new ItemInfo(AE_MATERIAL,  45), new ItemInfo(skystoneBlock, 0));
                }
            }

        }
    }

    private static class CrucibleStoneDefaults implements ICrucibleStoneDefaultRegistryProvider {

        @Override
        public void registerRecipeDefaults(CrucibleRegistry registry) {
            registry.register(new ItemStack(Blocks.field_150347_e), FluidRegistry.LAVA, 250);
        }
    }

    private static class CrucibleWoodDefaults implements ICrucibleWoodDefaultRegistryProvider {
        @Override
        public void registerRecipeDefaults(CrucibleRegistry registry) {
            Meltable water = new Meltable(FluidRegistry.WATER.getName(), 250, new BlockInfo(Blocks.field_150362_t, 0));
            registry.register(new ItemStack(Blocks.field_150362_t), FluidRegistry.WATER, 250);
            registry.register(new ItemStack(Blocks.field_150362_t, 1, 1), FluidRegistry.WATER, 250);
            registry.register(new ItemStack(Blocks.field_150362_t, 1, 2), FluidRegistry.WATER, 250);
            registry.register(new ItemStack(Blocks.field_150362_t, 1, 3), FluidRegistry.WATER, 250);
            registry.register(new ItemStack(Blocks.field_150361_u, 1, 0), FluidRegistry.WATER, 250);
            registry.register(new ItemStack(Blocks.field_150361_u, 1, 1), FluidRegistry.WATER, 250);

            registry.register(new ItemInfo(Blocks.field_150345_g, 0), water);
            registry.register(new ItemInfo(Blocks.field_150345_g, 1), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 1)));
            registry.register(new ItemInfo(Blocks.field_150345_g, 2), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 2)));
            registry.register(new ItemInfo(Blocks.field_150345_g, 3), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150362_t, 3)));
            registry.register(new ItemInfo(Blocks.field_150345_g, 4), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150361_u, 0)));
            registry.register(new ItemInfo(Blocks.field_150345_g, 5), water.copy().setTextureOverride(new BlockInfo(Blocks.field_150361_u, 1)));

            registry.register(new ItemInfo(Items.field_151034_e, 0), water);
        }
    }
}
